/* --------------------------------------------------------------------------
 *
 * License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Copyright (c) 2001 Schuyler Heath <sheath@jabber.org>
 *
 * Acknowledgements
 *
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 *
 * --------------------------------------------------------------------------*/
#include "jsm.h"

mreturn mod_node_deliver(mapi m, void *arg)
{
    if (m->user && m->user->sessions == NULL && m->packet->flag == 1)
    {
        char *id = (char *) arg;
        xmlnode r;

        log_debug("mod_node","Resending packet");

        r = xmlnode_wrap(m->packet->x,"route");
        xmlnode_put_attrib(r,"to",id);
        deliver(dpacket_new(r),m->si->i);
        return M_HANDLED;
    }
    return M_PASS;
}

mreturn mod_node_in(mapi m, void *arg)
{ /* flag that this packet came from a session for node_deliver */
    m->packet->flag = 1;
    return M_PASS;
}

mreturn mod_node_session(mapi m, void *arg)
{
    js_mapi_session(es_IN,m->s,mod_node_in,NULL);
    return M_PASS;
}

void mod_node(jsmi si)
{
    char *id;

    id = pstrdup(si->p,xmlnode_get_tag_data(js_config(si,"node"),"id"));

    if (id == NULL)
    {
        log_error("mod_node","Failed to load config!");
        return;
    }

    js_mapi_register(si,e_SESSION,mod_node_session,NULL);
    js_mapi_register(si,e_DELIVER,mod_node_deliver,(void *) id);
}
