/* --------------------------------------------------------------------------
 *
 * License
 *
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License.  You
 * may obtain a copy of the License at http://www.jabber.com/license/ or at
 * http://www.opensource.org/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Copyright (c) 2001 Schuyler Heath <sheath@jabber.org>
 *
 * Acknowledgements
 *
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 *
 * --------------------------------------------------------------------------*/

#include "jabberd.h"

/* I dunno about SESSION_* yet, they may go away */
#define SESSION_START 0  /* remote session start */
#define SESSION_END 1    /* remove session end */
#define PACKET_FARM 2    /* received from the farm */
#define PACKET_DELIVER 3 /* received from jabberd deliver callback */

typedef struct
{
    pool p;
    void *cb;
    void *arg;
} *modcall, _modcall;

typedef struct
{
    pool p;
    instance i;
    xdbcache xc;
    xmlnode cfg;

    mio m;
    xht remote_sessions;
    char *ip, *secret;
    int port;
    int state;
    int timeout;
    modcall events[5];
} *fni, _fni;

typedef struct
{
    pool p;
    fni ni;
    jid id;
} *rmts, _rmts;

typedef result (*node_dpacket_cb)   (fni fi, dpacket d, void *arg); /* callback for PACKET_* */
typedef void   (*node_session_cb)   (rmts r, void *arg);            /* callback for SESSION_* */

xmlnode node_config(fni ni, char *tag);
void node_register(fni ni, int event, void *cb, void *arg);

/* these allow modules control what causes a session start or end */
void node_session_end(fni ni, jid id);
void node_session_start(fni ni, jid id);

/* this sends the xmlnode to the master */
void node_route(fni ni, xmlnode x);

/* this sends the xmlnode directly to a farm node or the
   master if that fails.  Used for inter-node routing only. */
void node_inter_route(fni ni, xmlnode x);
